# Simulations

Ce dépôt contient l'ensemble du code pour les simulations basées sur simIRT. Afin d'économiser de la place sur le serveur, les données générées ne sont pas inclues dans le dépôt mais sont disponibles sur https://osf.io.

## Arborescence

```
📦 simul_these
├─ catalogue.md           - List and description of scenarios
├─ 🗂️ Analysis               - ANALYSIS RESULTS
├─ 🗂️ Data                   - GENERATED DATASETS
│  ├─ 🗂️ DIF                 - DATASETS WITH DIF
│  └─ 🗂️ noDIF               - DATASETS WITHOUT DIF
├─ 🗂️ Modules                - R AND STATA MODULES
│  ├─ 🗂️ rosali_custom       - DATASETS WITH DIF
│  ├─ simirt.do
│  └─ simirt.R
├─ 🗂️ Plans                  - SIMULATION PLANS
├─ 🗂️ RProject               - R SCRIPTS FOR COMPILING RESULTS
└─ 🗂️ Scripts                - R AND STATA SCRIPTS
   ├─ 🗂️ Analysis            - PCM ANALYSIS SCRIPTS
   ├─ 🗂️ R                   - VARIOUS USEFUL R SCRIPTS
   └─ 🗂️ Scenarios           - SIMULATION SCENARIO SCRIPTS
      ├─ 🗂️ DIF
      └─ 🗂️ noDIF

```

## Conventions de nomenclature

### Jeux de données initiaux

**XX_N** - Scénarios de référence sans confusion / N réplications  
**1XX_N** - Scénarios avec confusion induite par 1 covariable / N réplications  
**2XX_N** - Scénarios avec confusion induite par 2 covariables / N réplications  
**3XX_N** - Scénarios avec confusion induite par 1 covariable induisant du DIF / N réplications

### Jeux de données analysés

**noDIF / XX_N.csv** - Analyse du scénario XX_N par PCM __sans__ prise en compte du DIF  
**DIF / XX_N.xls** - Analyse du scénario XX_N par PCM __avec__ prise en compte du DIF  
**ROSALI-DIF / XX_N_original.xls** - Analyse du scénario XX_N par PCM __avec__ prise en compte du DIF détecté par ROSALI-DIF  
**RESALI / XX_N_original.xls** - Analyse du scénario XX_N par PCM __avec__ prise en compte du DIF détecté par la méthode des résidus de Andrich & Hagquist  


## Reproduction

1. Lancer **/Scripts/Scenarios/NoDIF/scenarios_noDIF_baseline.do** pour simuler les données des scénarios sans DIF
2. Lancer tous les fichiers dans 🗂️ **/Scripts/Scenarios/DIF/** pour simuler les données des scénarios avec DIF
3. Lancer **/RProject/Scripts/pcm_nodif.R** pour analyser les données sans prise en compte du DIF
4. Lancer les fichiers dans 🗂️ **/Scripts/Analysis/DIF/** pour analyser les données avec prise en compte du DIF
5. Lancer **/Scripts/Analysis/DIF-ROSALI/pcm_dif_rosali.do** pour analyser les données avec prise en compte du DIF détecté par ROSALI-DIF
6. Lancer **/Scripts/Analysis/DIF-RESIDUS/pcm_dif_residus.do** pour analyser les données avec prise en compte du DIF détecté par la méthode des résidus
7. Lancer **/RProject/Scripts/aggregation.R** pour compiler les résultats dans des tableaux complets
